import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useCallback, useState } from 'react';
import purebem from 'purebem';
import { FoundationButton } from '@billogram/foundation-button';
import { FoundationControl, FoundationControlGroup } from '@billogram/foundation-control-group';
import { pgettext } from '@billogram/lang';
import FoundationPanel from './FoundationPanel';
import './FoundationSectionPanel.scss';
export default function FoundationSectionPanel(_ref) {
  var _ref$canEdit = _ref.canEdit,
      canEdit = _ref$canEdit === void 0 ? true : _ref$canEdit,
      _ref$canToggle = _ref.canToggle,
      canToggle = _ref$canToggle === void 0 ? false : _ref$canToggle,
      _ref$children = _ref.children,
      children = _ref$children === void 0 ? null : _ref$children,
      _ref$description = _ref.description,
      description = _ref$description === void 0 ? null : _ref$description,
      _ref$editButtonText = _ref.editButtonText,
      editButtonText = _ref$editButtonText === void 0 ? pgettext('generic-action', 'Edit') : _ref$editButtonText,
      _ref$title = _ref.title,
      title = _ref$title === void 0 ? null : _ref$title;
  var block = purebem('foundation-section-panel');

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      isEditing = _useState2[0],
      setIsEditing = _useState2[1];

  var close = useCallback(function close() {
    setIsEditing(false);
  }, []);
  var open = useCallback(function open() {
    setIsEditing(true);
  }, []);
  var content = typeof children === 'function' ? children({
    close: close,
    isEditing: isEditing,
    open: open
  }) : children;
  return React.createElement(FoundationPanel, null, React.createElement("div", {
    className: block()
  }, title !== null && title !== '' ? React.createElement("div", {
    className: block('title')
  }, title) : null, description !== null && description !== '' ? React.createElement("div", {
    className: block('description')
  }, description) : null, canToggle && !isEditing ? React.createElement("div", {
    className: block('actions')
  }, React.createElement(FoundationControlGroup, null, React.createElement(FoundationControl, null, React.createElement(FoundationButton, {
    disabled: !canEdit,
    onClick: open
  }, editButtonText)))) : null, content !== null ? React.createElement(React.Fragment, null, React.createElement("hr", {
    className: block('separator')
  }), content) : null));
}
//# sourceMappingURL=FoundationSectionPanel.js.map